// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import "OWAddress-OHActions.h"

#import <Foundation/NSString.h>
#import <Foundation/Foundation.h>
#import <OmniBase/OmniBase.h>
#import <OmniFoundation/OmniFoundation.h>
#import <OWF/OWF.h>

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniHTML/Support.subproj/OWAddress-OHActions.m,v 1.3 2000/01/20 00:27:59 kc Exp $")

@implementation OWAddress (AppSupport)

- (void)addToBookmarks;
{
    [[NSNotificationCenter defaultCenter] postNotificationName:OWAddressAddToBookmarksNotification object:self];
}

- (void)openDocumentInNewWindow;
{
    [[NSNotificationCenter defaultCenter] postNotificationName:OWAddressOpenDocumentInNewWindowNotification object:self];
}

- (void)openDocumentInNewWindowAtScreenPoint:(NSPoint)screenPoint;
{
    NSMutableDictionary *userInfoDictionary;

    userInfoDictionary = [[NSMutableDictionary alloc] initWithCapacity:1];
    [userInfoDictionary setObject:[NSValue valueWithPoint:screenPoint] forKey:OWAddressOpenDocumentInNewWindowScreenPointKey];
    [[NSNotificationCenter defaultCenter] postNotificationName:OWAddressOpenDocumentInNewWindowNotification object:self userInfo:userInfoDictionary];
}

@end

DEFINE_NSSTRING(OWAddressOpenDocumentInNewWindowNotification);
DEFINE_NSSTRING(OWAddressOpenDocumentInNewWindowScreenPointKey);
DEFINE_NSSTRING(OWAddressAddToBookmarksNotification);
